<template>
<div id="app">
  <v-app id="inspire">
    <v-row justify="center">
      <v-col cols="12" sm="8">
        <v-card>
          <v-card-title class="cyan darken-1">
            <span class="headline white&#45;&#45;text">{{currentContact.name}}</span>

            <v-spacer></v-spacer>

            <v-btn class="mr-5" v-if="isEditing" color="indigo" dark @click="saveChangeContact(currentContact.id)">
              Save
            </v-btn>

            <v-btn dark icon @click="backToContacts()">
              <v-icon>mdi-chevron-left</v-icon>
            </v-btn>

            <v-btn class="mr-5" v-if="undoButtonEnabled" color="indigo" dark icon @click="undo()">
              Undo
            </v-btn>

            <v-btn class="mr-5" v-if="redoButtonEnabled" color="indigo" dark icon @click="redo()">
              Redo
            </v-btn>

            <v-btn dark icon @click="toggleEditing()">
              <v-icon>mdi-pencil</v-icon>
            </v-btn>

          </v-card-title>
          <v-img
            src="https://picsum.photos/700?image=996"
            height="200px"
          ></v-img>

                <EditableForm
                  :items="currentContact.phoneNumber"
                  :icon="'mdi-phone'"
                  :id="currentContact.id"
                  :contactKey="'phoneNumber'"
                />
                <EditableForm
                  :items="currentContact.email"
                  :icon="'mdi-email'"
                  :id="currentContact.id"
                  :contactKey="'email'"
                />

        </v-card>
      </v-col>
    </v-row>
  </v-app>
</div>
</template>

<script>
import EditableForm from './EditableForm'
import {mapActions, mapState} from 'vuex'

export default {
  name: 'movies',
  components: {
    EditableForm,
  },
  computed: mapState({
    isEditing: state => state.isEditing,
    currentContact: state => state.currentContact,
    undoButtonEnabled: "canUndo",
    redoButtonEnabled: "canRedo",

  }),
  mounted() {
    const url = this.$router.history.current.path.split('/')
    const id = url[url.length-1]
    this.targetContact(id)
  },
  methods: {
    ...mapActions(['toggleEditing', 'targetContact', 'addEmail', 'saveChange', 'undo', 'redo']),
    backToContacts() {
      this.$router.back()
    },
    saveChangeContact(id) {
      this.saveChange(id)
      this.toggleEditing()
    },
  }
}
</script>
